# =============================================================================
# >> IMPORTS
# =============================================================================
# Source.Python Imports
from Source import Player
from Source import Engine
from Source import Entity
from threading import Timer
#   Events
from events.decorator import Event
#   Messages
from messages import Chat

# =============================================================================
# >> CONFIG
# =============================================================================

# Protection time
prot_time = 10


# =============================================================================
# >> GAME EVENTS
# =============================================================================

@Event
def player_spawn(GameEvent):
#   Chat Messages
    userid = GameEvent.GetInt('userid')
    player = Player.EdictOfUserid(userid)
    index = Engine.IndexOfEdict(player)
    Chat(index, '[Spawnprotection] Enabled!')
    say_delay = Timer(prot_time, Chat, (index, '[Spawnprotection] Disabled!'))
    say_delay.start()
#   Godmode
    player.SetPropInt("CBaseAnimating.m_nHitboxSet", 2)
    prot_delay = Timer(prot_time, player.SetPropInt, ["CBaseAnimating.m_nHitboxSet", 0])
    prot_delay.start()
#   Color settings
    playerx = Player.PlayerOfUserid(userid)
    real_color = (255*65792+255)
    if playerx.GetTeamIndex() == 2:
        color = (255*2)
    if playerx.GetTeamIndex() == 3:
        color = (255*65536)
        player.SetPropInt("CBaseEntity.m_clrRender", color)
        rc_delay = Timer(prot_time, player.SetPropInt, ["CBaseEntity.m_clrRender", real_color])
        rc_delay.start()

